<?php

   //-------- YAPS Options : START
   $yapservice = "yaps.mine.nu";  // where the yaps service is located
   $secure     = true;            // change it to false if You wan't use SSL
   //-------- YAPS Options : END
   
   
   //-------- YAPS DNS-Request : START   
   function yapsDNS($dns, $remotehost, $ssl = false){
      
      $http_response = "";
      $ssl == true ? $remotehost = "ssl://".$remotehost.":4433" : $remotehost = "http://".$remotehost.":8080";

      $link = sprintf("%s/?q=%s&mod=remote", $remotehost, $dns);
      $url = parse_url($link);
      $fp = fsockopen($url['scheme']."://".$url['host'], $url['port'], $err_num, $err_msg, 30) or die("Socket-open failed--error: ".$err_num." ".$err_msg);
      fputs($fp, "GET /".$url['path']."?".$url['query']." HTTP/1.0\n");
      fputs($fp, "User-agent: YaPS 0.2\r\n");
      fputs($fp, "Connection: close\n\n");
      while(!feof($fp)) {
        $http_response = fgets($fp, 128);
      }
      fclose($fp);
      
      switch($http_response){
        case "true" : return "<font color=red>! Risk !</font>";
          break;
        case "false" : return "<font color=#5EFB6E>OK</font>";
          break;
        default : return "Unknow Error";
      }
   }
   //-------- YAPS DNS-Request function : END
   
  
   //-------- YAPS Stats-Request function : START   
   function yapsStats($remotehost, $action, $ssl = false){
      
      $http_response = "";
      $ssl == true ? $remotehost = "ssl://".$remotehost.":4433" : $remotehost = "http://".$remotehost.":8080";

      $link = sprintf("%s/?q=&action=%s", $remotehost, $action);
      $url = parse_url($link);
      $fp = fsockopen($url['scheme']."://".$url['host'], $url['port'], $err_num, $err_msg, 30) or die("Socket-open failed--error: ".$err_num." ".$err_msg);
      fputs($fp, "GET /".$url['path']."?".$url['query']." HTTP/1.0\n");
      fputs($fp, "User-agent: YaPS 0.2\r\n");
      fputs($fp, "Connection: close\n\n");
      while(!feof($fp)) {
        $http_response = fgets($fp, 128);
      }
      fclose($fp);
      
      return htmlentities($http_response);
   }
   //-------- YAPS Stats-Request function : END
   
   
   include "common.php";
   include "meniu.php";
   
   format1("Yet Another Payserver Service", "v0.2");
   format1("Database version", yapsStats($yapservice, "date", $secure));
   format1("Database rows", yapsStats($yapservice, "rows", $secure));
   format1("Payserver hits", yapsStats($yapservice, "hits", $secure));
   loadServersHosts();
   ksort($ServerHost_Conectat);
   echo "<br />";	  
   echo "<table border=0 cellpadding=1 cellspacing=1>";
   echo "<tr>";
	 echo "<td width=250 class=\"Node_ID\">Server</td>";
	 echo "<td width=50 class=\"Node_ID\">Status</td>";
	 echo "</tr>";
   echo "</table>"; 
   
   $oldserver = "";
   foreach ($ServerHost_Conectat as $sh_host => $server_Time)
   {
      ob_flush();
      flush();
      
      list($host_DNS, $host_PORT) = explode(":", $sh_host);
      $newserver = $host_DNS;

      if($newserver != $oldserver){

        if ($host_PORT > 0)
        {
  	      $yaps = yapsDNS($host_DNS, $yapservice, $secure);
  	      usleep(100000);
  	    }
  	    echo "<table border=0 cellpadding=1 cellspacing=1>";
     		echo "<tr>";
  	    echo "<td width=250 class=\"Node_ID\"><A HREF=".$pagina."?nodeDns=$sh_host>".$sh_host."</A></td>";	
  	    echo "<td width=50 class=\"tabel_normal\"><A HREF=http://$yapservice:8080/?q=$host_DNS target=_blank>".$yaps."</A></td>";
  	    echo "</tr>";
  	    echo "</table>";
  	  }
  	  
	    $oldserver = $newserver;
   }
   

	 ENDPage();
?>
